/****************************************************************************
Module name: Setup.H
Programmer : Jeffrey M. Richter.
*****************************************************************************/

#include "dialog.h"

// Defines used by the SETUP program.
#define MAXPATH   80
#define MAXDRIVE  3
#define MAXDIR    66
#define MAXFILE   9
#define MAXEXT    5
#define MAXFILENAME  (MAXFILE + MAXEXT)

extern char _szAppName[];
extern HANDLE _hInstance;
extern char _szSrcDir[MAXDIR];
extern char _szDstDir[MAXDIR];

// Prototypes for various functions.
BOOL FAR PASCAL RegisterDDEClient (HANDLE hInstance);
BOOL FAR PASCAL WelcomeDlgProc (HWND hDlg, WORD wMsg, WORD wParam, LONG lParam);
BOOL FAR PASCAL StatusDlgProc (HWND hDlg, WORD wMsg, WORD wParam, LONG lParam);
BOOL FAR PASCAL InsertDiskDlgProc (HWND hDlg, WORD wMsg, WORD wParam, LONG lParam);

int FAR cdecl MsgBox (HANDLE hInstance, HWND hWnd, WORD wID,
                   LPSTR szCaption, WORD wType, ...);


// Defines for use with SETUP's string table.
#define IDS_NOMETERLIB        1000
#define IDS_NOMEMORY          1001
#define IDS_NOSETUPINFOFILE   1002
#define IDS_NODISKSPACE       1003
#define IDS_CANTMAKEDIR       1004
#define IDS_QUERYABORT        1005
#define IDS_SETUPNOGOOD       1006
#define IDS_SETUPOKNOPM       1007
#define IDS_SETUPDONE         1008
#define IDS_PMADDOK           1009
#define IDS_PMADDNOGOOD       1010
#define IDS_NOMEMORYCOPY      1011
#define IDS_CANTOPENDST       1012

//*********** Macros for use by Window and Class Extra Bytes *****************

#define offsetof(Struct, Member) \
   ((unsigned int) &(((Struct NEAR *) 0)->Member))

#define GETWNDEB(hWnd, Struct, Member) \
   ((sizeof(((Struct FAR *)0)->Member) == sizeof(DWORD)) ? \
      GetWindowLong(hWnd, offsetof(Struct, Member)) : \
      GetWindowWord(hWnd, offsetof(Struct, Member)))

#define SETWNDEB(hWnd, Struct, Member, Value) \
   ((sizeof(((Struct FAR *)0)->Member) == sizeof(DWORD)) ? \
      SetWindowLong(hWnd, offsetof(Struct, Member), Value) : \
      SetWindowWord(hWnd, offsetof(Struct, Member), (WORD) Value))

#define GETCLSEB(hWnd, Struct, Member) \
   ((sizeof(((Struct FAR *)0)->Member) == sizeof(DWORD)) ? \
      GetClassLong(hWnd, offsetof(Struct, Member)) : \
      GetClassWord(hWnd, offsetof(Struct, Member)))

#define SETCLSEB(hWnd, Struct, Member, Value) \
   ((sizeof(((Struct FAR *)0)->Member) == sizeof(DWORD)) ? \
      SetClassLong(hWnd, offsetof(Struct, Member), Value) : \
      SetClassWord(hWnd, offsetof(Struct, Member), (WORD) Value))
